Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 7299)
@@ -22,7 +22,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:) ::   pot_astro   !
 
-#if defined key_tide
    !!----------------------------------------------------------------------
-   !!   'key_tide' :                                        tidal potential
+   !!   tidal potential
    !!----------------------------------------------------------------------
    !!   sbc_tide            : 
@@ -30,5 +29,4 @@
    !!----------------------------------------------------------------------
 
-   LOGICAL, PUBLIC, PARAMETER ::   lk_tide  = .TRUE.
    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   amp_pot, phi_pot
 
@@ -125,16 +123,4 @@
    END SUBROUTINE tide_init_potential
 
-#else
-  !!----------------------------------------------------------------------
-  !!   Default case :   Empty module
-  !!----------------------------------------------------------------------
-  LOGICAL, PUBLIC, PARAMETER ::   lk_tide = .FALSE.
-CONTAINS
-  SUBROUTINE sbc_tide( kt )      ! Empty routine
-    INTEGER         , INTENT(in) ::   kt         ! ocean time-step
-    WRITE(*,*) 'sbc_tide: You should not have seen this print! error?', kt
-  END SUBROUTINE sbc_tide
-#endif
-
   !!======================================================================
 END MODULE sbctide
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 7299)
@@ -12,6 +12,6 @@
    !!----------------------------------------------------------------------
    USE oce            ! 
-   USE sbc_oce	       ! Surface boundary condition: ocean fields
-   USE bdy_oce        !
+   USE sbc_oce        ! Surface boundary condition: ocean fields
+   USE bdy_oce   , ONLY: ln_bdy, bdytmask
    USE domvvl         !
    !
@@ -19,5 +19,5 @@
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! distribued memory computing library
-   USE fldread	       ! read input fields
+   USE fldread        ! read input fields
    USE wrk_nemo       !
 
@@ -32,6 +32,6 @@
    INTEGER , PARAMETER ::   jp_wn  = 3   ! index of wave number                 (1/m)    at T-point
 
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:)  :: sf_cd	  ! structure of input fields (file informations, fields read) Drag Coefficient
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:)  :: sf_sd	  ! structure of input fields (file informations, fields read) Stokes Drift
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:)  :: sf_cd         ! structure of input fields (file informations, fields read) Drag Coefficient
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:)  :: sf_sd         ! structure of input fields (file informations, fields read) Stokes Drift
 
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION (:,:)   :: cdn_wave 
@@ -172,11 +172,11 @@
             wsd3d(:,:,jk) = wsd3d(:,:,jk+1) - ze3hdiv(:,:,jk)
          END DO
-#if defined key_bdy
-         IF( lk_bdy ) THEN
+         !
+         IF( ln_bdy ) THEN
             DO jk = 1, jpkm1
                wsd3d(:,:,jk) = wsd3d(:,:,jk) * bdytmask(:,:)
             END DO
          ENDIF
-#endif
+         !
          CALL wrk_dealloc( jpi,jpj,jpk,   zusd_t, zvsd_t, ze3hdiv )
          ! 
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/tideini.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/tideini.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/tideini.F90	(revision 7299)
@@ -25,4 +25,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:) ::   ftide        !:
 
+   LOGICAL , PUBLIC ::   ln_tide         !:
    LOGICAL , PUBLIC ::   ln_tide_pot     !:
    LOGICAL , PUBLIC ::   ln_tide_ramp    !:
@@ -48,14 +49,6 @@
       INTEGER  ::   ios                 ! Local integer output status for namelist read
       !
-      NAMELIST/nam_tide/ln_tide_pot, ln_tide_ramp, rdttideramp, clname
+      NAMELIST/nam_tide/ln_tide, ln_tide_pot, ln_tide_ramp, rdttideramp, clname
       !!----------------------------------------------------------------------
-      !
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'tide_init : Initialization of the tidal components'
-         WRITE(numout,*) '~~~~~~~~~ '
-      ENDIF
-      !
-      CALL tide_init_Wave
       !
       ! Read Namelist nam_tide
@@ -69,4 +62,25 @@
       IF(lwm) WRITE ( numond, nam_tide )
       !
+      IF (ln_tide) THEN
+         IF (lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'tide_init : Initialization of the tidal components'
+            WRITE(numout,*) '~~~~~~~~~ '
+            WRITE(numout,*) '   Namelist nam_tide'
+            WRITE(numout,*) '              Use tidal components : ln_tide      = ', ln_tide
+            WRITE(numout,*) '      Apply astronomical potential : ln_tide_pot  = ', ln_tide_pot
+            WRITE(numout,*) '                                     nb_harmo     = ', nb_harmo
+            WRITE(numout,*) '                                     ln_tide_ramp = ', ln_tide_ramp
+            WRITE(numout,*) '                                     rdttideramp  = ', rdttideramp
+         ENDIF
+      ELSE
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'tide_init : tidal components not used (ln_tide = F)'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~ '
+         RETURN
+      ENDIF
+      !
+      CALL tide_init_Wave
+      !
       nb_harmo=0
       DO jk = 1, jpmax_harmo
@@ -79,11 +93,4 @@
       IF( nb_harmo == 0 )   CALL ctl_stop( 'tide_init : No tidal components set in nam_tide' )
       !
-      IF(lwp) THEN
-         WRITE(numout,*) '   Namelist nam_tide'
-         WRITE(numout,*) '      Apply astronomical potential : ln_tide_pot  =', ln_tide_pot
-         WRITE(numout,*) '                                     nb_harmo     = ', nb_harmo
-         WRITE(numout,*) '                                     ln_tide_ramp = ', ln_tide_ramp 
-         WRITE(numout,*) '                                     rdttideramp  = ', rdttideramp
-      ENDIF
       IF( ln_tide_ramp.AND.((nitend-nit000+1)*rdt/rday < rdttideramp) )   &
          &   CALL ctl_stop('rdttideramp must be lower than run duration')
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/updtide.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/updtide.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/updtide.F90	(revision 7299)
@@ -5,8 +5,4 @@
    !!======================================================================
    !! History :  9.0  !  07  (O. Le Galloudec)  Original code
-   !!----------------------------------------------------------------------
-#if defined key_tide
-   !!----------------------------------------------------------------------
-   !!   'key_tide' :                                        tidal potential
    !!----------------------------------------------------------------------
    !!   upd_tide       : update tidal potential
@@ -81,18 +77,4 @@
    END SUBROUTINE upd_tide
 
-#else
-  !!----------------------------------------------------------------------
-  !!   Dummy module :                                        NO TIDE
-  !!----------------------------------------------------------------------
-CONTAINS
-  SUBROUTINE upd_tide( kt, kit, time_offset )  ! Empty routine
-    INTEGER, INTENT(in)           ::   kt      !  integer  arg, dummy routine
-    INTEGER, INTENT(in), OPTIONAL ::   kit     !  optional arg, dummy routine
-    INTEGER, INTENT(in), OPTIONAL ::   time_offset !  optional arg, dummy routine
-    WRITE(*,*) 'upd_tide: You should not have seen this print! error?', kt
-  END SUBROUTINE upd_tide
-
-#endif
-
   !!======================================================================
 
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 7299)
@@ -37,5 +37,5 @@
    USE ldftra          ! lateral physics on tracers
    USE ldfslp
-   USE bdy_oce         ! BDY open boundary condition variables
+   USE bdy_oce   , ONLY: ln_bdy
    USE bdytra          ! open boundary condition (bdy_tra routine)
    !
@@ -79,5 +79,5 @@
       !!              - Apply lateral boundary conditions on (ta,sa) 
       !!             at the local domain   boundaries through lbc_lnk call, 
-      !!             at the one-way open boundaries (lk_bdy=T), 
+      !!             at the one-way open boundaries (ln_bdy=T), 
       !!             at the AGRIF zoom   boundaries (lk_agrif=T)
       !!
@@ -111,7 +111,5 @@
       CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1._wp )
       !
-#if defined key_bdy 
-      IF( lk_bdy )   CALL bdy_tra( kt )  ! BDY open boundaries
-#endif
+      IF( ln_bdy )   CALL bdy_tra( kt )  ! BDY open boundaries
  
       ! set time step size (Euler/Leapfrog)
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7299)
@@ -205,5 +205,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
-               IF( fsdept(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
+               IF( gdept_n(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
                   avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk), rn_wvmix )
                   avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk), rn_wvmix )
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7299)
@@ -52,8 +52,6 @@
 #endif
    USE tideini        ! tidal components initialization   (tide_ini routine)
+   USE bdy_oce,   ONLY: ln_bdy
    USE bdyini         ! open boundary cond. setting       (bdy_init routine)
-   USE bdydta         ! open boundary cond. setting   (bdy_dta_init routine)
-   USE bdytides       ! open boundary cond. setting   (bdytide_init routine)
-   USE sbctide, ONLY  : lk_tide
    USE istate         ! initial state setting          (istate_init routine)
    USE ldfdyn         ! lateral viscosity setting      (ldfdyn_init routine)
@@ -433,12 +431,7 @@
       !                                      ! external forcing 
 !!gm to be added : creation and call of sbc_apr_init
-      IF( lk_tide       )   CALL    tide_init   ! tidal harmonics
+                            CALL    tide_init   ! tidal harmonics
                             CALL     sbc_init   ! surface boundary conditions (including sea-ice)
-!!gm ==>> bdy_init should call bdy_dta_init and bdytide_init  NOT in nemogcm !!!
-      IF( lk_bdy        )   CALL     bdy_init   ! Open boundaries initialisation
-      IF( lk_bdy        )   CALL bdy_dta_init   ! Open boundaries initialisation of external data arrays
-      IF( lk_bdy .AND. lk_tide )   &
-         &                  CALL bdytide_init   ! Open boundaries initialisation of tidal harmonic forcing
-         
+                            CALL     bdy_init   ! Open boundaries initialisation
       !                                      ! Ocean physics
       !                                         ! Vertical physics
@@ -659,7 +652,5 @@
       USE diadct    , ONLY: diadct_alloc 
 #endif 
-#if defined key_bdy
       USE bdy_oce   , ONLY: bdy_oce_alloc
-#endif
       !
       INTEGER :: ierr
@@ -676,7 +667,5 @@
       ierr = ierr + diadct_alloc    ()          ! 
 #endif 
-#if defined key_bdy
       ierr = ierr + bdy_oce_alloc   ()          ! bdy masks (incl. initialization)
-#endif
       !
       IF( lk_mpp    )   CALL mpp_sum( ierr )
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7299)
@@ -104,7 +104,7 @@
       ! Update external forcing (tides, open boundaries, and surface boundary condition (including sea-ice)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      IF( lk_tide    )   CALL sbc_tide( kstp )                   ! update tide potential
+      IF( ln_tide    )   CALL sbc_tide( kstp )                   ! update tide potential
       IF( ln_apr_dyn )   CALL sbc_apr ( kstp )                   ! atmospheric pressure (NB: call before bdy_dta which needs ssh_ib) 
-      IF( lk_bdy     )   CALL bdy_dta ( kstp, time_offset=+1 )   ! update dynamic & tracer data at open boundaries
+      IF( ln_bdy     )   CALL bdy_dta ( kstp, time_offset=+1 )   ! update dynamic & tracer data at open boundaries
                          CALL sbc     ( kstp )                   ! Sea Boundary Condition (including sea-ice)
 
@@ -200,5 +200,5 @@
       IF(  lk_asminc .AND. ln_asmiau .AND. ln_dyninc )   &
                &         CALL dyn_asm_inc   ( kstp )  ! apply dynamics assimilation increment
-      IF( lk_bdy     )   CALL bdy_dyn3d_dmp ( kstp )  ! bdy damping trends
+      IF( ln_bdy     )   CALL bdy_dyn3d_dmp ( kstp )  ! bdy damping trends
 #if defined key_agrif
       IF(.NOT. Agrif_Root())  & 
@@ -259,5 +259,5 @@
       IF( lk_trabbl  )   CALL tra_bbl       ( kstp )  ! advective (and/or diffusive) bottom boundary layer scheme
       IF( ln_tradmp  )   CALL tra_dmp       ( kstp )  ! internal damping trends
-      IF( lk_bdy     )   CALL bdy_tra_dmp   ( kstp )  ! bdy damping trends
+      IF( ln_bdy     )   CALL bdy_tra_dmp   ( kstp )  ! bdy damping trends
 #if defined key_agrif
       IF(.NOT. Agrif_Root())  & 
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7299)
@@ -47,6 +47,5 @@
    USE stopts 
 
-   USE bdy_par          ! for lk_bdy
-   USE bdy_oce          ! for dmp logical
+   USE bdy_oce    , ONLY: ln_bdy
    USE bdydta           ! open boundary condition data     (bdy_dta routine)
    USE bdytra           ! bdy cond. for tracers            (bdy_tra routine)
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90	(revision 7299)
@@ -59,9 +59,5 @@
    USE lbcnfd, ONLY: isendto, nsndto, nfsloop, nfeloop ! Setup of north fold exchanges
    USE icbstp          ! handle bergs, calving, themodynamics and transport
-#if defined key_bdy
    USE bdyini          ! open boundary cond. setting       (bdy_init routine). clem: mandatory for LIM3
-   USE bdydta          ! open boundary cond. setting   (bdy_dta_init routine). clem: mandatory for LIM3
-#endif
-   USE bdy_par
 
    IMPLICIT NONE
@@ -363,6 +359,5 @@
       !           the environment of ocean BDY. Therefore bdy is called in both OPA and SAS modules. 
       !           This is not clean and should be changed in the future. 
-      IF( lk_bdy        )   CALL     bdy_init
-      IF( lk_bdy        )   CALL bdy_dta_init
+                            CALL     bdy_init
       ! ==>
       
@@ -514,10 +509,6 @@
       USE diawri    , ONLY: dia_wri_alloc
       USE dom_oce   , ONLY: dom_oce_alloc
-#if defined key_bdy   
-      USE bdy_oce   , ONLY: bdy_oce_alloc
+      USE bdy_oce   , ONLY: ln_bdy, bdy_oce_alloc
       USE oce         ! clem: mandatory for LIM3 because needed for bdy arrays
-#else
-      USE oce       , ONLY : sshn, sshb, snwice_mass, snwice_mass_b, snwice_fmass
-#endif
       !
       INTEGER :: ierr,ierr1,ierr2,ierr3,ierr4,ierr5,ierr6,ierr7,ierr8
@@ -527,25 +518,23 @@
       ierr =        dia_wri_alloc   ()
       ierr = ierr + dom_oce_alloc   ()          ! ocean domain
-#if defined key_bdy
       ierr = ierr + bdy_oce_alloc   ()          ! bdy masks (incl. initialization)
-      ierr = ierr + oce_alloc       ()          ! (tsn...)
-#endif
-
-#if ! defined key_bdy
-       ALLOCATE( snwice_mass(jpi,jpj)  , snwice_mass_b(jpi,jpj),             &
-         &      snwice_fmass(jpi,jpj)  , STAT= ierr1 )
-      !
-      ! lim code currently uses surface temperature and salinity in tsn array for initialisation
-      ! and ub, vb arrays in ice dynamics, so allocate enough of arrays to use
-      ! clem: should not be needed. To be checked out
-      jpm = MAX(jp_tem, jp_sal)
-      ALLOCATE( tsn(jpi,jpj,1,jpm)  , STAT=ierr2 )
-      ALLOCATE( ub(jpi,jpj,1)       , STAT=ierr3 )
-      ALLOCATE( vb(jpi,jpj,1)       , STAT=ierr4 )
-      ALLOCATE( tsb(jpi,jpj,1,jpm)  , STAT=ierr5 )
-      ALLOCATE( sshn(jpi,jpj)       , STAT=ierr6 )
-      ALLOCATE( un(jpi,jpj,1)       , STAT=ierr7 )
-      ALLOCATE( vn(jpi,jpj,1)       , STAT=ierr8 )
-      ierr = ierr + ierr1 + ierr2 + ierr3 + ierr4 + ierr5 + ierr6 + ierr7 + ierr8
+# if ! defined key_lim2 && ! defined key_lim3
+         ierr = ierr + oce_alloc       ()          ! (tsn...)
+# else
+         ALLOCATE( snwice_mass(jpi,jpj)  , snwice_mass_b(jpi,jpj),             &
+            &      snwice_fmass(jpi,jpj)  , STAT= ierr1 )
+         !
+         ! lim code currently uses surface temperature and salinity in tsn array for initialisation
+         ! and ub, vb arrays in ice dynamics, so allocate enough of arrays to use
+         ! clem: should not be needed. To be checked out
+         jpm = MAX(jp_tem, jp_sal)
+         ALLOCATE( tsn(jpi,jpj,1,jpm)  , STAT=ierr2 )
+         ALLOCATE( ub(jpi,jpj,1)       , STAT=ierr3 )
+         ALLOCATE( vb(jpi,jpj,1)       , STAT=ierr4 )
+         ALLOCATE( tsb(jpi,jpj,1,jpm)  , STAT=ierr5 )
+         ALLOCATE( sshn(jpi,jpj)       , STAT=ierr6 )
+         ALLOCATE( un(jpi,jpj,1)       , STAT=ierr7 )
+         ALLOCATE( vn(jpi,jpj,1)       , STAT=ierr8 )
+         ierr = ierr + ierr1 + ierr2 + ierr3 + ierr4 + ierr5 + ierr6 + ierr7 + ierr8
 #endif
       !
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/SAS_SRC/step.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/SAS_SRC/step.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/SAS_SRC/step.F90	(revision 7299)
@@ -23,8 +23,6 @@
    USE eosbn2           ! equation of state                (eos_bn2 routine)
    USE diawri           ! Standard run outputs             (dia_wri routine)
-   USE bdy_par          ! clem: mandatory for LIM3
-#if defined key_bdy
+   USE bdy_oce   , ONLY: ln_bdy
    USE bdydta           ! clem: mandatory for LIM3
-#endif
    USE stpctl           ! time stepping control            (stp_ctl routine)
    !
@@ -82,7 +80,5 @@
       !           From SAS: ocean bdy data are wrong  (but we do not care) and ice bdy data are OK.  
       !           This is not clean and should be changed in the future. 
-#if defined key_bdy
-      IF( lk_bdy     )       CALL bdy_dta ( kstp, time_offset=+1 )   ! update dynamic & tracer data at open boundaries
-#endif
+      IF( ln_bdy     )       CALL bdy_dta ( kstp, time_offset=+1 )   ! update dynamic & tracer data at open boundaries
       ! ==>
                              CALL sbc    ( kstp )         ! Sea Boundary Condition (including sea-ice)
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7299)
@@ -33,6 +33,6 @@
    USE trdtra
    USE tranxt
+   USE bdy_oce   , ONLY: ln_bdy
    USE trcbdy          ! BDY open boundaries
-   USE bdy_par, only: lk_bdy
 # if defined key_agrif
    USE agrif_top_interp
@@ -99,5 +99,5 @@
       END DO
 
-      IF( lk_bdy )  CALL trc_bdy( kt )
+      IF( ln_bdy )  CALL trc_bdy( kt )
 
       !                                ! set time step size (Euler/Leapfrog)
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 7299)
@@ -25,6 +25,6 @@
    USE trcsbc          ! surface boundary condition          (trc_sbc routine)
    USE zpshde          ! partial step: hor. derivative       (zps_hde routine)
+   USE bdy_oce   , ONLY: ln_bdy
    USE trcbdy          ! BDY open boundaries
-   USE bdy_par, only: lk_bdy
 
 #if defined key_agrif
@@ -65,5 +65,5 @@
          IF( lk_trabbl )        CALL trc_bbl    ( kt )      ! advective (and/or diffusive) bottom boundary layer scheme
          IF( ln_trcdmp )        CALL trc_dmp    ( kt )      ! internal damping trends
-         IF( lk_bdy )           CALL trc_bdy_dmp( kt )      ! BDY damping trends
+         IF( ln_bdy )           CALL trc_bdy_dmp( kt )      ! BDY damping trends
                                 CALL trc_adv    ( kt )      ! horizontal & vertical advection 
          !                                                         ! Partial top/bottom cell: GRADh( trb )  
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7299)
@@ -14,7 +14,5 @@
    USE par_oce
    USE par_trc
-#if defined key_bdy
-   USE bdy_oce, only: nb_bdy, OBC_DATA
-#endif
+   USE bdy_oce, only: ln_bdy, nb_bdy, OBC_DATA
    
    IMPLICIT NONE
@@ -189,5 +187,4 @@
 # endif
    !
-#if defined key_bdy
    CHARACTER(len=20), PUBLIC, ALLOCATABLE,  SAVE,  DIMENSION(:)   ::  cn_trc_dflt          ! Default OBC condition for all tracers
    CHARACTER(len=20), PUBLIC, ALLOCATABLE,  SAVE,  DIMENSION(:)   ::  cn_trc               ! Choice of boundary condition for tracers
@@ -195,5 +192,4 @@
    ! External data structure of BDY for TOP. Available elements: cn_obc, ll_trc, trcnow, dmp
    TYPE(OBC_DATA),    PUBLIC, ALLOCATABLE, DIMENSION(:,:), TARGET ::  trcdta_bdy           !: bdy external data (local process)
-#endif
    !
 
@@ -210,6 +206,8 @@
       !!-------------------------------------------------------------------
       USE lib_mpp, ONLY: ctl_warn
+      INTEGER :: ierr(2)
       !!-------------------------------------------------------------------
       !
+      ierr(:) = 0
       ALLOCATE( trn(jpi,jpj,jpk,jptra), trb(jpi,jpj,jpk,jptra), tra(jpi,jpj,jpk,jptra),       &  
          &      trc_i(jpi,jpj,jptra)  , trc_o(jpi,jpj,jptra)                          ,       &
@@ -223,9 +221,13 @@
          &      ln_trc_sbc(jptra)     , ln_trc_cbc(jptra)     , ln_trc_obc(jptra)     ,       &
 #endif
-#if defined key_bdy
-         &      cn_trc_dflt(nb_bdy)   , cn_trc(nb_bdy)        , nn_trcdmp_bdy(nb_bdy) ,       &
+         &      STAT = ierr(1)  )
+
+      IF ( ln_bdy ) THEN
+         ALLOCATE( cn_trc_dflt(nb_bdy)   , cn_trc(nb_bdy)     , nn_trcdmp_bdy(nb_bdy) ,       &
          &      trcdta_bdy(jptra,nb_bdy)                                              ,       &
-#endif
-         &      STAT = trc_alloc  )
+         &      STAT = ierr(2)  )
+      ENDIF
+         !
+      trc_alloc = MAXVAL( ierr )
 
       IF( trc_alloc /= 0 )   CALL ctl_warn('trc_alloc: failed to allocate arrays')
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/trcbc.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/trcbc.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/TOP_SRC/trcbc.F90	(revision 7299)
@@ -19,7 +19,5 @@
    USE lib_mpp       !  MPP library
    USE fldread       !  read input fields
-#if defined key_bdy
-   USE bdy_oce, only: nb_bdy , idx_bdy, ln_coords_file, rn_time_dmp, rn_time_dmp_out
-#endif
+   USE bdy_oce,  ONLY: ln_bdy, nb_bdy , idx_bdy, ln_coords_file, rn_time_dmp, rn_time_dmp_out
 
    IMPLICIT NONE
@@ -78,7 +76,6 @@
       !!
       NAMELIST/namtrc_bc/ cn_dir_sbc, cn_dir_cbc, cn_dir_obc, sn_trcobc, rn_trofac, sn_trcsbc, rn_trsfac, sn_trccbc, rn_trcfac
-#if defined key_bdy
       NAMELIST/namtrc_bdy/ cn_trc_dflt, cn_trc, nn_trcdmp_bdy
-#endif
+
       !!----------------------------------------------------------------------
       IF( nn_timing == 1 )  CALL timing_start('trc_bc_init')
@@ -128,37 +125,38 @@
       IF(lwm) WRITE ( numont, namtrc_bc )
 
-#if defined key_bdy
-      REWIND( numnat_ref )              ! Namelist namtrc_bc in reference namelist : Passive tracer data structure
-      READ  ( numnat_ref, namtrc_bdy, IOSTAT = ios, ERR = 903)
-903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_bdy in reference namelist', lwp )
-
-      REWIND( numnat_cfg )              ! Namelist namtrc_bc in configuration namelist : Passive tracer data structure
-      READ  ( numnat_cfg, namtrc_bdy, IOSTAT = ios, ERR = 904 )
-904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_bdy in configuration namelist', lwp )
-      IF(lwm) WRITE ( numont, namtrc_bdy )
-      ! setup up preliminary informations for BDY structure
-      DO jn = 1, ntrc
-         DO ib = 1, nb_bdy
-            ! Set type of obc in BDY data structure (around here we may plug user override of obc type from nml)
-            IF ( ln_trc_obc(jn) ) THEN
-               trcdta_bdy(jn,ib)%cn_obc = TRIM( cn_trc(ib) )
-            ELSE
-               trcdta_bdy(jn,ib)%cn_obc = TRIM( cn_trc_dflt(ib) )
-            ENDIF
-            ! set damping use in BDY data structure
-            trcdta_bdy(jn,ib)%dmp = .false.
-            IF(nn_trcdmp_bdy(ib) .EQ. 1 .AND. ln_trc_obc(jn) ) trcdta_bdy(jn,ib)%dmp = .true.
-            IF(nn_trcdmp_bdy(ib) .EQ. 2 ) trcdta_bdy(jn,ib)%dmp = .true.
-            IF(trcdta_bdy(jn,ib)%cn_obc == 'frs' .AND. nn_trcdmp_bdy(ib) .NE. 0 )  &
-                & CALL ctl_stop( 'Use FRS OR relaxation' )
-            IF (nn_trcdmp_bdy(ib) .LT. 0 .OR. nn_trcdmp_bdy(ib) .GT. 2)            &
-                & CALL ctl_stop( 'Not a valid option for nn_trcdmp_bdy. Allowed: 0,1,2.' )
+      IF ( ln_bdy ) THEN
+         REWIND( numnat_ref )              ! Namelist namtrc_bdy in reference namelist : Passive tracer data structure
+         READ  ( numnat_ref, namtrc_bdy, IOSTAT = ios, ERR = 903)
+903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_bdy in reference namelist', lwp )
+
+         REWIND( numnat_cfg )              ! Namelist namtrc_bdy in configuration namelist : Passive tracer data structure
+         READ  ( numnat_cfg, namtrc_bdy, IOSTAT = ios, ERR = 904 )
+904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_bdy in configuration namelist', lwp )
+         IF(lwm) WRITE ( numont, namtrc_bdy )
+      
+         ! setup up preliminary informations for BDY structure
+         DO jn = 1, ntrc
+            DO ib = 1, nb_bdy
+               ! Set type of obc in BDY data structure (around here we may plug user override of obc type from nml)
+               IF ( ln_trc_obc(jn) ) THEN
+                  trcdta_bdy(jn,ib)%cn_obc = TRIM( cn_trc(ib) )
+               ELSE
+                  trcdta_bdy(jn,ib)%cn_obc = TRIM( cn_trc_dflt(ib) )
+               ENDIF
+               ! set damping use in BDY data structure
+               trcdta_bdy(jn,ib)%dmp = .false.
+               IF(nn_trcdmp_bdy(ib) .EQ. 1 .AND. ln_trc_obc(jn) ) trcdta_bdy(jn,ib)%dmp = .true.
+               IF(nn_trcdmp_bdy(ib) .EQ. 2 ) trcdta_bdy(jn,ib)%dmp = .true.
+               IF(trcdta_bdy(jn,ib)%cn_obc == 'frs' .AND. nn_trcdmp_bdy(ib) .NE. 0 )  &
+                   & CALL ctl_stop( 'Use FRS OR relaxation' )
+               IF (nn_trcdmp_bdy(ib) .LT. 0 .OR. nn_trcdmp_bdy(ib) .GT. 2)            &
+                   & CALL ctl_stop( 'Not a valid option for nn_trcdmp_bdy. Allowed: 0,1,2.' )
+            ENDDO
          ENDDO
-      ENDDO
-
-#else
-      ! Force all tracers OBC to false if bdy not used
-      ln_trc_obc = .false.
-#endif
+      ELSE
+         ! Force all tracers OBC to false if bdy not used
+         ln_trc_obc = .false.
+      ENDIF
+
       ! compose BC data indexes
       DO jn = 1, ntrc
@@ -198,6 +196,6 @@
          WRITE(numout,*) ' '
          WRITE(numout,'(a,i3)') '   Total tracers to be initialized with OPEN BCs data:', nb_trcobc
-#if defined key_bdy
-         IF ( nb_trcobc > 0 ) THEN
+
+         IF ( ln_bdy .AND. nb_trcobc > 0 ) THEN
             WRITE(numout,*) '   #trc        NAME        Boundary     Mult.Fact.   OBC Settings'
             DO jn = 1, ntrc
@@ -217,5 +215,5 @@
             ENDDO
          ENDIF
-#endif
+
          WRITE(numout,'(2a)') '   OPEN BC data repository : ', TRIM(cn_dir_obc)
       ENDIF
@@ -225,7 +223,6 @@
 
       !
-#if defined key_bdy
       ! OPEN Lateral boundary conditions
-      IF( nb_trcobc > 0 ) THEN 
+      IF( ln_bdy .AND. nb_trcobc > 0 ) THEN 
          ALLOCATE ( sf_trcobc(nb_trcobc), rf_trofac(nb_trcobc), nbmap_ptr(nb_trcobc), STAT=ierr1 )
          IF( ierr1 > 0 ) THEN
@@ -272,5 +269,5 @@
          CALL fld_fill( sf_trcobc, slf_i, cn_dir_obc, 'trc_bc_init', 'Passive tracer OBC data', 'namtrc_bc' )
       ENDIF
-#endif
+
       ! SURFACE Boundary conditions
       IF( nb_trcsbc > 0 ) THEN       !  allocate only if the number of tracer to initialise is greater than zero
